var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import * as React from 'react';
import classNames from 'classnames';
import Icon from "../icon";
import "./style/radio.css";
var prefixCls = 'dmc-radio';

var getIconAttr = function getIconAttr(on) {
  return on ? ['radio-on', 'checked'] : ['radio-off', 'uncheck'];
};

export var Radio = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _a;

  var type = props.type,
      size = props.size,
      checked = props.checked,
      defaultChecked = props.defaultChecked,
      value = props.value,
      className = props.className,
      children = props.children,
      disabled = props.disabled,
      onChange = props.onChange,
      restProps = __rest(props, ["type", "size", "checked", "defaultChecked", "value", "className", "children", "disabled", "onChange"]);

  var val = !!('checked' in props ? checked : defaultChecked);
  var wrapperCls = classNames(prefixCls, (_a = {}, _a[prefixCls + "-" + type] = type, _a[prefixCls + "-" + size] = size, _a[prefixCls + "-disabled"] = disabled, _a), className);

  var _b = getIconAttr(val),
      icon = _b[0],
      status = _b[1];

  var handleChange = function handleChange() {
    onChange && onChange(value);
  };

  return _jsxs("div", __assign({}, restProps, {
    ref: ref,
    className: wrapperCls,
    onClick: disabled ? undefined : handleChange
  }, {
    children: [_jsx(Icon, {
      icon: icon,
      className: prefixCls + "-icon-" + status
    }, void 0), !!children && _jsx("span", __assign({
      className: prefixCls + "-info"
    }, {
      children: children
    }), void 0)]
  }), void 0);
});
Radio.displayName = 'Radio';
export default Radio;
var RadioMemo = /*#__PURE__*/React.memo(Radio);
RadioMemo.displayName = 'RadioMemo';
export { RadioMemo };

